(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (factory((global.reduxProgress = {})));
}(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var _this = undefined;
    (function (Status) {
        Status["resolved"] = "resolved";
        Status["rejected"] = "rejected";
        Status["pending"] = "pending";
        Status["none"] = "none";
    })(exports.Status || (exports.Status = {}));
    var map = function (self, mapper) {
        if (!mapper) {
            return self;
        }
        var result;
        try {
            result = Progress.resolve(mapper());
        }
        catch (e) {
            result = Progress.reject(e);
        }
        return self.equals(result) ? self : result;
    };
    var Progress = /** @class */ (function () {
        function Progress() {
        }
        /* @deprecated Use then */
        Progress.prototype.map = function (mapper) {
            // console.warn('Progress.map is deprecated. Use then');
            return this.then(mapper);
        };
        /* @deprecated Use then */
        Progress.prototype.flatMap = function (mapper) {
            // console.warn('Progress.flatMap is deprecated. Use then');
            return this.then(mapper);
        };
        Object.defineProperty(Progress, "inProgress", {
            /* @deprecated Use pending */
            get: function () {
                // console.warn('Progress.inProgress is deprecated. Use pending');
                return Progress.pending;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "success", {
            /* @deprecated Use isResolved */
            get: function () {
                // console.warn('Progress.success is deprecated. Use isResolved');
                return this.isResolved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "inProgress", {
            /* @deprecated Use isPending */
            get: function () {
                // console.warn('Progress.inProgress is deprecated. Use isPending');
                return this.isPending;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "failed", {
            /* @deprecated Use isRejected */
            get: function () {
                // console.warn('Progress.failed is deprecated. Use isRejected');
                return this.isRejected;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "result", {
            /* @deprecated Use value */
            get: function () {
                // console.warn('Progress.result is deprecated. Use value');
                return this.value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "isCompleted", {
            /* @deprecated Use isFulfilled */
            get: function () {
                // console.warn('Progress.isCompleted is deprecated. Use isFulfilled');
                return this.isFulfilled;
            },
            enumerable: true,
            configurable: true
        });
        /* @deprecated Use get */
        Progress.prototype.unwrap = function () {
            // console.warn('Progress.unwrap is deprecated. Use get');
            return this.get();
        };
        /* @deprecated Use then().value */
        Progress.prototype.ifSuccess = function (mapper) {
            // console.warn('Progress.ifSuccess is deprecated. Use then().value');
            return this.then(mapper).value || null;
        };
        /* @deprecated Use when().value */
        Progress.prototype.fold = function (mapper) {
            // console.warn('Progress.fold is deprecated. Use when().value');
            return this.when({
                none: mapper.none,
                pending: mapper.loading,
                resolved: mapper.success,
                rejected: mapper.failed,
            }).value || null;
        };
        Object.defineProperty(Progress.prototype, "isNone", {
            get: function () {
                return this.status === exports.Status.none;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "isPending", {
            get: function () {
                return this.status === exports.Status.pending;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "isResolved", {
            get: function () {
                return this.status === exports.Status.resolved;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "isRejected", {
            get: function () {
                return this.status === exports.Status.rejected;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Progress.prototype, "isFulfilled", {
            get: function () {
                return this.isRejected || this.isResolved;
            },
            enumerable: true,
            configurable: true
        });
        Progress.prototype.ifNone = function (supplier) {
            return this;
        };
        Progress.prototype.ifPending = function (supplier) {
            return this;
        };
        Progress.prototype.then = function (mapper, errorMapper) {
            return this;
        };
        Progress.prototype.catch = function (errorMapper) {
            return this;
        };
        Progress.prototype.finally = function (supplier) {
            return this.then(supplier, supplier);
        };
        Progress.prototype.get = function () {
            throw new Error('Progress not completed');
        };
        Progress.prototype.equals = function (progress) {
            return progress &&
                progress instanceof Progress &&
                this.status === progress.status &&
                this.value === progress.value &&
                this.error === progress.error;
        };
        Progress.resolve = function (r) {
            if (r instanceof Progress) {
                return r;
            }
            return new Resolved(r);
        };
        Progress.reject = function (error) { return new Rejected(error); };
        Progress.pending = (function () {
            var Pending = /** @class */ (function (_super) {
                __extends(Pending, _super);
                function Pending() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.status = exports.Status.pending;
                    return _this;
                }
                Pending.prototype.ifPending = function (supplier) {
                    return map(this, supplier);
                };
                Pending.prototype.when = function (mapper) {
                    return this.ifPending(mapper.pending);
                };
                return Pending;
            }(Progress));
            return new Pending();
        })();
        Progress.none = (function () {
            var None = /** @class */ (function (_super) {
                __extends(None, _super);
                function None() {
                    var _this = _super !== null && _super.apply(this, arguments) || this;
                    _this.status = exports.Status.none;
                    return _this;
                }
                None.prototype.ifNone = function (supplier) {
                    return map(this, supplier);
                };
                None.prototype.when = function (mapper) {
                    return this.ifNone(mapper.none);
                };
                return None;
            }(Progress));
            return new None();
        })();
        Progress.all = function () {
            var targets = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                targets[_i] = arguments[_i];
            }
            return targets.find(function (p) { return p.isRejected; }) ||
                targets.find(function (p) { return p.isPending; }) ||
                targets.find(function (p) { return p.isNone; }) ||
                Progress.resolve(targets.map(function (p) { return p.value; }));
        };
        Progress.race = function () {
            var targets = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                targets[_i] = arguments[_i];
            }
            return targets.find(function (p) { return p.isFulfilled; }) || targets.find(function (p) { return p.isPending; }) || targets[0] || Progress.none;
        };
        /* @deprecated Use resolve */
        Progress.success = function (r) {
            // console.warn('Progress.success is deprecated. Use resolve');
            return Progress.resolve(r);
        };
        /* @deprecated Use reject */
        Progress.fail = function (error) {
            // console.warn('Progress.fail is deprecated. Use reject');
            return Progress.reject(error);
        };
        return Progress;
    }());
    var Resolved = /** @class */ (function (_super) {
        __extends(Resolved, _super);
        function Resolved(result) {
            var _this = _super.call(this) || this;
            _this.status = exports.Status.resolved;
            _this.value = result;
            return _this;
        }
        Resolved.prototype.get = function () {
            return this.value;
        };
        Resolved.prototype.then = function (mapper) {
            var _this = this;
            return map(this, mapper && (function () { return mapper(_this.value); }));
        };
        Resolved.prototype.when = function (mapper) {
            return this.then(mapper.resolved);
        };
        return Resolved;
    }(Progress));
    var Rejected = /** @class */ (function (_super) {
        __extends(Rejected, _super);
        function Rejected(error) {
            var _this = _super.call(this) || this;
            _this.status = exports.Status.rejected;
            _this.error = error;
            return _this;
        }
        Rejected.prototype.get = function () {
            throw this.error;
        };
        Rejected.prototype.then = function (mapper, errorMapper) {
            return this.catch(errorMapper);
        };
        Rejected.prototype.catch = function (mapper) {
            var _this = this;
            return map(this, mapper && (function () { return mapper(_this.error); }));
        };
        Rejected.prototype.when = function (mapper) {
            return this.catch(mapper.rejected);
        };
        return Rejected;
    }(Progress));
    var from = function (serialized) {
        if (serialized instanceof Progress) {
            return serialized;
        }
        switch (serialized.status) {
            case exports.Status.resolved:
                return Progress.resolve(serialized.value);
            case exports.Status.rejected:
                return Progress.reject(serialized.error);
            case exports.Status.pending:
                return Progress.pending;
            case exports.Status.none:
                return Progress.none;
            default:
                throw new Error("Unknown Progress type: " + serialized.status);
        }
    };
    var thunk = function (type, promiseOrFunc, extras) { return function (dispatch) { return __awaiter(_this, void 0, void 0, function () {
        var action, progress, promise, result, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    action = function (type, progress, extras) { return (__assign({}, extras, { type: type, progress: progress })); };
                    dispatch(action(type, Progress.pending, extras));
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    promise = (promiseOrFunc instanceof Function) ? promiseOrFunc() : promiseOrFunc;
                    return [4 /*yield*/, promise];
                case 2:
                    result = _a.sent();
                    progress = Progress.resolve(result);
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    progress = Progress.reject(error_1);
                    return [3 /*break*/, 4];
                case 4:
                    dispatch(action(type, progress, extras));
                    return [2 /*return*/, progress];
            }
        });
    }); }; };
    /* @deprecated Use thunk */
    var thunkProgress = thunk;
    /* @deprecated */
    var inProgress = Progress.inProgress, success = Progress.success, fail = Progress.fail;
    var none = Progress.none, pending = Progress.pending, resolve = Progress.resolve, reject = Progress.reject, all = Progress.all, race = Progress.race;

    exports.Progress = Progress;
    exports.from = from;
    exports.thunk = thunk;
    exports.thunkProgress = thunkProgress;
    exports.default = Progress;
    exports.inProgress = inProgress;
    exports.success = success;
    exports.fail = fail;
    exports.none = none;
    exports.pending = pending;
    exports.resolve = resolve;
    exports.reject = reject;
    exports.all = all;
    exports.race = race;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=redux-progress.umd.js.map
